using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.AClasses;
using ff14bot.Behavior;
using TreeSharp;
using System.Windows.Forms;
using Action = TreeSharp.Action;

namespace ExCombatAssist
{
    public class ExCombatAssist : BotBase
    {
        public override string Name
        {
            get { return "Ex Combat Assist"; }
        }


        public override bool WantButton
        {
            get
            {
                return false;
            }
        }

        public override void Start()
        {
            Navigator.PlayerMover = new NullMover();
            GameSettingsManager.FaceTargetOnAction = false;
        }

        public override void Stop()
        {

        }

        public override PulseFlags PulseFlags
        {
            get { return PulseFlags.All; }
        }

        private Composite _root;
        public override Composite Root
        {
            get
            {
                return _root ?? (_root =
                    new PrioritySelector(

                           new Decorator(ret => {

                                if (!Core.Player.InCombat)
                                    return false;

                                if (!Core.Player.HasTarget)
                                    return false;

                                return true;

                            }, new PrioritySelector(
                                RoutineManager.Current.CombatBuffBehavior,
                                RoutineManager.Current.HealBehavior,
                                RoutineManager.Current.CombatBehavior
                                
                                )),

                            new Decorator(ret =>
                            {

                                if (!Core.Player.InCombat && Core.Player.HasTarget)
                                    return false;

                                return true;

                            }, new PrioritySelector(
                                RoutineManager.Current.HealBehavior)),


                            new Decorator(ret => {

                                if (Core.Player.InCombat)
                                    return false;

                                return true;

                            }, new PrioritySelector(
                                RoutineManager.Current.HealBehavior )),

                                RoutineManager.Current.HealBehavior
     
                   ));
            }
        }

        public override bool RequiresProfile
        {
            get { return false; }
        }

    }
}
